Blame


1 0e673013 2019-01-02 stsp #!/bin/sh
2 0e673013 2019-01-02 stsp #
3 5aa81393 2020-01-06 stsp # Copyright (c) 2019, 2020 Stefan Sperling <stsp@openbsd.org>
4 0e673013 2019-01-02 stsp #
5 0e673013 2019-01-02 stsp # Permission to use, copy, modify, and distribute this software for any
6 0e673013 2019-01-02 stsp # purpose with or without fee is hereby granted, provided that the above
7 0e673013 2019-01-02 stsp # copyright notice and this permission notice appear in all copies.
8 0e673013 2019-01-02 stsp #
9 0e673013 2019-01-02 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 0e673013 2019-01-02 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 0e673013 2019-01-02 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 0e673013 2019-01-02 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 0e673013 2019-01-02 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 0e673013 2019-01-02 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 0e673013 2019-01-02 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 0e673013 2019-01-02 stsp
17 f81387ac 2023-02-17 thomas regress_run_only=""
18 f81387ac 2023-02-17 thomas
19 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_NAME="Flan Hacker"
20 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_EMAIL="flan_hacker@openbsd.org"
21 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"
22 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"
23 0b2899f8 2019-08-18 stsp export GOT_AUTHOR="$GIT_AUTHOR_NAME <$GIT_AUTHOR_EMAIL>"
24 82f6abb8 2019-08-14 stsp export GOT_AUTHOR_8="flan_hac"
25 e600f124 2021-03-21 stsp export GOT_AUTHOR_11="flan_hacker"
26 b1ebc001 2019-08-13 stsp export GOT_LOG_DEFAULT_LIMIT=0
27 11f4fa81 2020-10-01 stsp export GOT_TEST_ROOT="/tmp"
28 1f240092 2022-07-24 thomas export GOT_IGNORE_GITCONFIG=1
29 113392cf 2023-01-23 thomas export GOT_VERSION_STR=`got --version | cut -d ' ' -f2`
30 bc3928c7 2024-04-25 thomas.ad export GOT_TEST_HTTP_PORT=8080
31 e4db89da 2023-03-05 thomas
32 e4db89da 2023-03-05 thomas export LC_ALL=C
33 c3754a5b 2019-05-10 stsp
34 7b67836a 2019-05-10 stsp export MALLOC_OPTIONS=S
35 d3b82051 2022-07-10 thomas
36 e33b5f97 2023-03-05 thomas if [ "$(date -u -r 86400 +%F 2>/dev/null)" != 1970-01-02 ]; then
37 e33b5f97 2023-03-05 thomas DATECMD=
38 e33b5f97 2023-03-05 thomas for p in date gdate; do
39 e33b5f97 2023-03-05 thomas if [ "$($p -u -d @86400 +%F 2>/dev/null)" = 1970-01-02 ]; then
40 e33b5f97 2023-03-05 thomas DATECMD=$p
41 e33b5f97 2023-03-05 thomas break
42 e33b5f97 2023-03-05 thomas fi
43 1c72bab5 2023-03-03 thomas done
44 e33b5f97 2023-03-05 thomas if [ -z "$DATECMD" ]; then
45 e33b5f97 2023-03-05 thomas echo "Couldn't find gdate, is GNU coreutils installed?" >&2
46 e33b5f97 2023-03-05 thomas exit 1
47 e33b5f97 2023-03-05 thomas fi
48 fa37079f 2021-10-09 thomas
49 e33b5f97 2023-03-05 thomas date()
50 e33b5f97 2023-03-05 thomas {
51 e33b5f97 2023-03-05 thomas local flag r u
52 e33b5f97 2023-03-05 thomas while getopts r:u flag; do
53 e33b5f97 2023-03-05 thomas case $flag in
54 e33b5f97 2023-03-05 thomas r) r=$OPTARG ;;
55 e33b5f97 2023-03-05 thomas u) u=-u ;;
56 e33b5f97 2023-03-05 thomas ?) exit 1 ;;
57 e33b5f97 2023-03-05 thomas esac
58 e33b5f97 2023-03-05 thomas done
59 e33b5f97 2023-03-05 thomas shift $((OPTIND - 1))
60 e33b5f97 2023-03-05 thomas command "$DATECMD" $u ${r+-d"@$r"} "$@"
61 e33b5f97 2023-03-05 thomas }
62 e33b5f97 2023-03-05 thomas fi
63 e33b5f97 2023-03-05 thomas
64 f6cae3ed 2020-09-13 naddy git_init()
65 0e673013 2019-01-02 stsp {
66 0b2899f8 2019-08-18 stsp git init -q "$1"
67 f60607c8 2021-09-30 thomas
68 f60607c8 2021-09-30 thomas # Switch the default branch to match our test expectations if needed.
69 f60607c8 2021-09-30 thomas # Only need to change HEAD since 'git init' did not create any refs.
70 f60607c8 2021-09-30 thomas # Relying on implementation details of 'git init' is no problem for us.
71 f60607c8 2021-09-30 thomas # We want to be alerted when Git changes fundamental assumptions such
72 f60607c8 2021-09-30 thomas # as what an empty repository looks like and where the default branch
73 f60607c8 2021-09-30 thomas # is set. In such cases Got's own tooling might well need to change
74 f60607c8 2021-09-30 thomas # its behaviour, too, and our tests should fail.
75 f60607c8 2021-09-30 thomas # TODO: Update all tests to assume 'main' instead of 'master' and
76 f60607c8 2021-09-30 thomas # switch to main here, to match Got's own default.
77 f60607c8 2021-09-30 thomas echo "ref: refs/heads/master" > "$1/.git/HEAD"
78 0e673013 2019-01-02 stsp }
79 0e673013 2019-01-02 stsp
80 f6cae3ed 2020-09-13 naddy maybe_pack_repo()
81 b32c4525 2020-01-05 stsp {
82 b32c4525 2020-01-05 stsp local repo="$1"
83 b32c4525 2020-01-05 stsp if [ -n "$GOT_TEST_PACK" ]; then
84 a628577a 2023-02-17 thomas arg=""
85 a628577a 2023-02-17 thomas if [ "$GOT_TEST_PACK" = "ref-delta" ]; then
86 a628577a 2023-02-17 thomas arg="-D"
87 a628577a 2023-02-17 thomas fi
88 a628577a 2023-02-17 thomas
89 a628577a 2023-02-17 thomas (cd $repo && gotadmin pack -a $arg > /dev/null)
90 a628577a 2023-02-17 thomas (cd $repo && gotadmin cleanup -a -q)
91 b32c4525 2020-01-05 stsp fi
92 b32c4525 2020-01-05 stsp }
93 b32c4525 2020-01-05 stsp
94 f6cae3ed 2020-09-13 naddy git_commit()
95 0e673013 2019-01-02 stsp {
96 0e673013 2019-01-02 stsp local repo="$1"
97 0e673013 2019-01-02 stsp shift
98 d1e03b8c 2023-10-08 thomas git -C $repo commit --author="$GOT_AUTHOR" -q -a "$@"
99 b32c4525 2020-01-05 stsp maybe_pack_repo $repo
100 0e673013 2019-01-02 stsp }
101 0e673013 2019-01-02 stsp
102 f6cae3ed 2020-09-13 naddy git_rm()
103 512f0d0e 2019-01-02 stsp {
104 512f0d0e 2019-01-02 stsp local repo="$1"
105 512f0d0e 2019-01-02 stsp shift
106 d1e03b8c 2023-10-08 thomas git -C $repo rm -q "$@"
107 512f0d0e 2019-01-02 stsp }
108 512f0d0e 2019-01-02 stsp
109 870ddae5 2023-03-10 thomas git_rmdir()
110 870ddae5 2023-03-10 thomas {
111 870ddae5 2023-03-10 thomas local repo="$1"
112 870ddae5 2023-03-10 thomas shift
113 d1e03b8c 2023-10-08 thomas git -C $repo rm -q -r "$@"
114 870ddae5 2023-03-10 thomas }
115 870ddae5 2023-03-10 thomas
116 f6cae3ed 2020-09-13 naddy git_show_head()
117 9c4b8182 2019-01-02 stsp {
118 9c4b8182 2019-01-02 stsp local repo="$1"
119 d1e03b8c 2023-10-08 thomas git -C $repo show --no-patch --pretty='format:%H'
120 9c4b8182 2019-01-02 stsp }
121 9c4b8182 2019-01-02 stsp
122 f6cae3ed 2020-09-13 naddy git_show_branch_head()
123 db32465d 2020-02-07 stsp {
124 db32465d 2020-02-07 stsp local repo="$1"
125 db32465d 2020-02-07 stsp local branch="$2"
126 d1e03b8c 2023-10-08 thomas git -C $repo show --no-patch --pretty='format:%H' $branch
127 db32465d 2020-02-07 stsp }
128 db32465d 2020-02-07 stsp
129 db32465d 2020-02-07 stsp
130 f6cae3ed 2020-09-13 naddy git_show_author_time()
131 bcb49d15 2019-08-14 stsp {
132 bcb49d15 2019-08-14 stsp local repo="$1"
133 01073a5d 2019-08-22 stsp local object="$2"
134 d1e03b8c 2023-10-08 thomas git -C $repo show --no-patch --pretty='format:%at' $object
135 bcb49d15 2019-08-14 stsp }
136 bcb49d15 2019-08-14 stsp
137 f6cae3ed 2020-09-13 naddy git_show_tagger_time()
138 8e7bd50a 2019-08-22 stsp {
139 8e7bd50a 2019-08-22 stsp local repo="$1"
140 8e7bd50a 2019-08-22 stsp local tag="$2"
141 d1e03b8c 2023-10-08 thomas git -C $repo cat-file tag $tag | grep ^tagger | \
142 d1e03b8c 2023-10-08 thomas sed -e "s/^tagger $GOT_AUTHOR//" | cut -d' ' -f2
143 8e7bd50a 2019-08-22 stsp }
144 8e7bd50a 2019-08-22 stsp
145 f6cae3ed 2020-09-13 naddy git_show_parent_commit()
146 818c7501 2019-07-11 stsp {
147 818c7501 2019-07-11 stsp local repo="$1"
148 70551d57 2020-04-24 stsp local commit="$2"
149 d1e03b8c 2023-10-08 thomas git -C $repo show --no-patch --pretty='format:%P' $commit
150 818c7501 2019-07-11 stsp }
151 818c7501 2019-07-11 stsp
152 f6cae3ed 2020-09-13 naddy git_show_tree()
153 03415a1a 2019-06-02 stsp {
154 03415a1a 2019-06-02 stsp local repo="$1"
155 d1e03b8c 2023-10-08 thomas git -C $repo show --no-patch --pretty='format:%T'
156 03415a1a 2019-06-02 stsp }
157 03415a1a 2019-06-02 stsp
158 f6cae3ed 2020-09-13 naddy trim_obj_id()
159 818c7501 2019-07-11 stsp {
160 9439a990 2020-09-16 naddy local trimcount=$1
161 9439a990 2020-09-16 naddy local id=$2
162 818c7501 2019-07-11 stsp
163 9439a990 2020-09-16 naddy local pat=""
164 9439a990 2020-09-16 naddy while [ "$trimcount" -gt 0 ]; do
165 818c7501 2019-07-11 stsp pat="[0-9a-f]$pat"
166 9439a990 2020-09-16 naddy trimcount=$((trimcount - 1))
167 818c7501 2019-07-11 stsp done
168 818c7501 2019-07-11 stsp
169 818c7501 2019-07-11 stsp echo ${id%$pat}
170 9139e004 2023-07-17 thomas }
171 9139e004 2023-07-17 thomas
172 8642913b 2023-07-26 thomas pop_idx()
173 9139e004 2023-07-17 thomas {
174 9139e004 2023-07-17 thomas shift "$1"
175 9139e004 2023-07-17 thomas printf '%s' "${1:-index-out-of-bounds}"
176 818c7501 2019-07-11 stsp }
177 818c7501 2019-07-11 stsp
178 f6cae3ed 2020-09-13 naddy git_commit_tree()
179 03415a1a 2019-06-02 stsp {
180 03415a1a 2019-06-02 stsp local repo="$1"
181 03415a1a 2019-06-02 stsp local msg="$2"
182 03415a1a 2019-06-02 stsp local tree="$3"
183 d1e03b8c 2023-10-08 thomas git -C $repo commit-tree -m "$msg" "$tree"
184 03415a1a 2019-06-02 stsp }
185 03415a1a 2019-06-02 stsp
186 f0fd0aaf 2021-09-14 stsp git_fsck()
187 f0fd0aaf 2021-09-14 stsp {
188 f0fd0aaf 2021-09-14 stsp local testroot="$1"
189 f0fd0aaf 2021-09-14 stsp local repo="$2"
190 f0fd0aaf 2021-09-14 stsp
191 d1e03b8c 2023-10-08 thomas git -C $repo fsck --strict \
192 d1e03b8c 2023-10-08 thomas > $testroot/fsck.stdout 2> $testroot/fsck.stderr
193 fc414659 2022-04-16 thomas ret=$?
194 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
195 f0fd0aaf 2021-09-14 stsp echo -n "git fsck: "
196 f0fd0aaf 2021-09-14 stsp cat $testroot/fsck.stderr
197 f0fd0aaf 2021-09-14 stsp echo "git fsck failed; leaving test data in $testroot"
198 f0fd0aaf 2021-09-14 stsp return 1
199 f0fd0aaf 2021-09-14 stsp fi
200 f0fd0aaf 2021-09-14 stsp
201 f0fd0aaf 2021-09-14 stsp return 0
202 f0fd0aaf 2021-09-14 stsp }
203 f0fd0aaf 2021-09-14 stsp
204 f6cae3ed 2020-09-13 naddy make_test_tree()
205 0e673013 2019-01-02 stsp {
206 0e673013 2019-01-02 stsp repo="$1"
207 0e673013 2019-01-02 stsp
208 0e673013 2019-01-02 stsp echo alpha > $repo/alpha
209 0e673013 2019-01-02 stsp echo beta > $repo/beta
210 0e673013 2019-01-02 stsp mkdir $repo/gamma
211 0e673013 2019-01-02 stsp echo delta > $repo/gamma/delta
212 0e673013 2019-01-02 stsp mkdir $repo/epsilon
213 0e673013 2019-01-02 stsp echo zeta > $repo/epsilon/zeta
214 0e673013 2019-01-02 stsp }
215 0e673013 2019-01-02 stsp
216 f6cae3ed 2020-09-13 naddy make_single_file_repo()
217 e7303626 2020-05-14 stsp {
218 e7303626 2020-05-14 stsp repo="$1"
219 e7303626 2020-05-14 stsp file="$2"
220 e7303626 2020-05-14 stsp
221 e7303626 2020-05-14 stsp mkdir $repo
222 e7303626 2020-05-14 stsp git_init $repo
223 e7303626 2020-05-14 stsp echo "this is file $file" > $repo/$file
224 d1e03b8c 2023-10-08 thomas git -C $repo add .
225 e7303626 2020-05-14 stsp git_commit $repo -m "intialize $repo with file $file"
226 e7303626 2020-05-14 stsp }
227 e7303626 2020-05-14 stsp
228 f6cae3ed 2020-09-13 naddy get_loose_object_path()
229 e7303626 2020-05-14 stsp {
230 e7303626 2020-05-14 stsp local repo="$1"
231 e7303626 2020-05-14 stsp local id="$2"
232 e7303626 2020-05-14 stsp local id0=`trim_obj_id 38 $id`
233 e7303626 2020-05-14 stsp local idrest=`echo ${id#[0-9a-f][0-9a-f]}`
234 e7303626 2020-05-14 stsp echo "$repo/.git/objects/$id0/$idrest"
235 e7303626 2020-05-14 stsp }
236 e7303626 2020-05-14 stsp
237 f6cae3ed 2020-09-13 naddy get_blob_id()
238 3ce1b845 2019-07-15 stsp {
239 3ce1b845 2019-07-15 stsp repo="$1"
240 3ce1b845 2019-07-15 stsp tree_path="$2"
241 3ce1b845 2019-07-15 stsp filename="$3"
242 3ce1b845 2019-07-15 stsp
243 e8863bdc 2020-07-23 stsp got tree -r $repo -i $tree_path | grep "[0-9a-f] ${filename}$" | \
244 e8863bdc 2020-07-23 stsp cut -d' ' -f 1
245 3ce1b845 2019-07-15 stsp }
246 3ce1b845 2019-07-15 stsp
247 f6cae3ed 2020-09-13 naddy test_init()
248 0e673013 2019-01-02 stsp {
249 0e673013 2019-01-02 stsp local testname="$1"
250 4a1ddfc2 2019-01-12 stsp local no_tree="$2"
251 0e673013 2019-01-02 stsp if [ -z "$testname" ]; then
252 0e673013 2019-01-02 stsp echo "No test name provided" >&2
253 0e673013 2019-01-02 stsp return 1
254 0e673013 2019-01-02 stsp fi
255 d6e78555 2023-06-01 thomas local testroot=`mktemp -d \
256 d6e78555 2023-06-01 thomas "$GOT_TEST_ROOT/got-test-$testname-XXXXXXXXXX"`
257 0e673013 2019-01-02 stsp mkdir $testroot/repo
258 0e673013 2019-01-02 stsp git_init $testroot/repo
259 4a1ddfc2 2019-01-12 stsp if [ -z "$no_tree" ]; then
260 4a1ddfc2 2019-01-12 stsp make_test_tree $testroot/repo
261 d1e03b8c 2023-10-08 thomas git -C $repo add .
262 4a1ddfc2 2019-01-12 stsp git_commit $testroot/repo -m "adding the test tree"
263 4a1ddfc2 2019-01-12 stsp fi
264 c8c71e6e 2020-03-21 stsp touch $testroot/repo/.git/git-daemon-export-ok
265 0e673013 2019-01-02 stsp echo "$testroot"
266 0e673013 2019-01-02 stsp }
267 0e673013 2019-01-02 stsp
268 f6cae3ed 2020-09-13 naddy test_cleanup()
269 0e673013 2019-01-02 stsp {
270 0e673013 2019-01-02 stsp local testroot="$1"
271 fe7842f5 2019-07-14 stsp
272 f0fd0aaf 2021-09-14 stsp git_fsck $testroot $testroot/repo
273 fc414659 2022-04-16 thomas ret=$?
274 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
275 f0fd0aaf 2021-09-14 stsp return $ret
276 fe7842f5 2019-07-14 stsp fi
277 fe7842f5 2019-07-14 stsp
278 0e673013 2019-01-02 stsp rm -rf "$testroot"
279 0e673013 2019-01-02 stsp }
280 0e673013 2019-01-02 stsp
281 f6cae3ed 2020-09-13 naddy test_parseargs()
282 7fb414ae 2020-08-08 stsp {
283 6c8da0c6 2020-10-03 naddy while getopts qr: flag; do
284 6c8da0c6 2020-10-03 naddy case $flag in
285 6c8da0c6 2020-10-03 naddy q) export GOT_TEST_QUIET=1
286 6c8da0c6 2020-10-03 naddy ;;
287 4f3c3d1e 2023-01-10 thomas r) export GOT_TEST_ROOT=${OPTARG%/}
288 6c8da0c6 2020-10-03 naddy ;;
289 6c8da0c6 2020-10-03 naddy ?) echo "Supported options:"
290 6c8da0c6 2020-10-03 naddy echo " -q: quiet mode"
291 6c8da0c6 2020-10-03 naddy echo " -r PATH: use PATH as test data root directory"
292 6c8da0c6 2020-10-03 naddy exit 2
293 6c8da0c6 2020-10-03 naddy ;;
294 7fb414ae 2020-08-08 stsp esac
295 7fb414ae 2020-08-08 stsp done
296 f81387ac 2023-02-17 thomas shift $(($OPTIND - 1))
297 f81387ac 2023-02-17 thomas regress_run_only="$@"
298 6c8da0c6 2020-10-03 naddy } >&2
299 7fb414ae 2020-08-08 stsp
300 f6cae3ed 2020-09-13 naddy run_test()
301 0e673013 2019-01-02 stsp {
302 0e673013 2019-01-02 stsp testfunc="$1"
303 f81387ac 2023-02-17 thomas
304 f81387ac 2023-02-17 thomas if [ -n "$regress_run_only" ]; then
305 f81387ac 2023-02-17 thomas case "$regress_run_only" in
306 f81387ac 2023-02-17 thomas *$testfunc*) ;;
307 f81387ac 2023-02-17 thomas *) return ;;
308 f81387ac 2023-02-17 thomas esac
309 f81387ac 2023-02-17 thomas fi
310 f81387ac 2023-02-17 thomas
311 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
312 7fb414ae 2020-08-08 stsp echo -n "$testfunc "
313 7fb414ae 2020-08-08 stsp fi
314 0e673013 2019-01-02 stsp $testfunc
315 0e673013 2019-01-02 stsp }
316 0e673013 2019-01-02 stsp
317 f6cae3ed 2020-09-13 naddy test_done()
318 0e673013 2019-01-02 stsp {
319 0e673013 2019-01-02 stsp local testroot="$1"
320 0e673013 2019-01-02 stsp local result="$2"
321 54c39596 2020-12-28 stsp if [ "$result" = "0" ]; then
322 fe7842f5 2019-07-14 stsp test_cleanup "$testroot" || return 1
323 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
324 7fb414ae 2020-08-08 stsp echo "ok"
325 7fb414ae 2020-08-08 stsp fi
326 3941b73a 2019-05-14 stsp elif echo "$result" | grep -q "^xfail"; then
327 3941b73a 2019-05-14 stsp # expected test failure; test reproduces an unfixed bug
328 3941b73a 2019-05-14 stsp echo "$result"
329 17201126 2019-07-14 stsp test_cleanup "$testroot" || return 1
330 0e673013 2019-01-02 stsp else
331 0e673013 2019-01-02 stsp echo "test failed; leaving test data in $testroot"
332 0e673013 2019-01-02 stsp fi
333 0e673013 2019-01-02 stsp }